
public class Medico extends Persona {

	private String specializzazione;
	
	private Prenotazione[] codaPrenotazioni;
	
	// Dati gestione coda
	private int head;
	private int tail;
	private int length;
	private int size;
	
	public Medico(String N, String C, String cf, 
			String spec, int DimCoda) {
		super(N, C, cf);
		specializzazione = spec;	
		
		length = DimCoda;
		head = 0;
		tail = 0;
		size = 0;
		
		codaPrenotazioni = new Prenotazione[length];
	}
	
	public String getInfo()
	{
		String info = nome + "\t" + cognome + "\t" + CF + "\t" + specializzazione;
		return info;
	}
	
	public boolean isAvailable()
	{
		if (size == length)
			return false;
		return true;
	}
	
	public int utentiInCoda()
	{
		return size;
	}
	

	public void stampaStatoCoda()
	{
		int i = 0;
		if (size == 0)
			System.out.println("Nessuna prenotazione");
		else
		{
			System.out.println("Prenotazioni in coda:");
			for (i = 0; i < size; i++) {
				System.out.println((i+1) + "\t" + codaPrenotazioni[(head + i) % length].stampaInfoPrenotazione());
			}
		}
		System.out.println();
	}
	
	public void accettaPazienteInCoda(Prenotazione P)
	{
		codaPrenotazioni[tail] = P;
		tail = (tail + 1) % length;
		size++;
	}
	
	public void curaProssimoPaziente(Ospedale o) 
	{
		if (size == 0)
		{
			System.out.println("Nessuna Prenotazione in coda");
		}
		else {
			Prenotazione temp = codaPrenotazioni[head];
			head = (head + 1) % length;
			size--;
			
			eseguiVisita(temp, o);
		}
	}
	
	private void eseguiVisita(Prenotazione p, Ospedale o)
	{
		Visita v = new Visita(this.CF, p.getPaziente().getDiagnosi(), p.getTrattamento(), o.getNome());
		p.getPaziente().aggiungiVisita(v);
		System.out.println("Visita eseguita " + p.stampaInfoPrenotazione());
	}

	@Override
	public void stampaInfo() {
		// TODO Auto-generated method stub
		System.out.println("Classe Medico");
	}
}
